--- /dev/null	2014-01-14 20:12:08.000000000 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/uctf/tst.userstrings.ksh	2014-01-14 20:12:08.424528514 -0500
@@ -0,0 +1,72 @@
+#! /usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2013 Joyent, Inc. All rights reserved.
+#
+
+#
+# This test is checking that we can read members and that pointers inside
+# members point to valid data that is intelligible, eg. strings.
+#
+
+if [ $# != 1 ]; then
+        echo expected one argument: '<'dtrace-path'>'
+        exit 2
+fi
+
+dtrace=$1
+exe="tst.chasestrings.exe"
+
+elfdump "./$exe" | grep -q '.SUNW_ctf' 
+if [[ $? -ne 0 ]]; then
+	echo "CTF does not exist in $exe, that's a bug" >&2
+	exit 1
+fi
+
+./$exe &
+pid=$!
+
+$dtrace -qs /dev/stdin <<EOF
+pid$pid::has_princess:entry
+/next == 0/
+{
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(args[0]->zi_gamename), args[0]->zi_ndungeons,
+	    stringof(args[0]->zi_villain), args[0]->zi_haszelda);
+	next = 1;
+}
+
+pid$pid::has_dungeons:entry
+/next == 1/
+{
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(args[0]->zi_gamename), args[0]->zi_ndungeons,
+	    stringof(args[0]->zi_villain), args[0]->zi_haszelda);
+	next = 2;
+}
+
+pid$pid::has_villain:entry
+/next == 2/
+{
+	printf("game: %s, dungeon: %d, villain: %s, zelda: %d\n",
+	    stringof(args[0]->zi_gamename), args[0]->zi_ndungeons,
+	    stringof(args[0]->zi_villain), args[0]->zi_haszelda);
+	exit(0);
+}
+EOF
+rc=$?
+
+kill -9 $pid
+
+exit $rc
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.corruptenv.ksh	2014-01-14 20:12:08.896489047 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.corruptenv.ksh	2014-01-14 20:12:08.932929988 -0500
@@ -60,10 +60,10 @@
 all: main
 
 main: main.o prov.o
-	gcc -o main main.o prov.o
+	gcc -m32 -o main main.o prov.o
 
 main.o: main.c prov.h
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 prov.h: prov.d
 	$dtrace -h -s prov.d
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose1.ksh	2014-01-14 20:12:09.383729470 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose1.ksh	2014-01-14 20:12:09.398725058 -0500
@@ -45,17 +45,17 @@
 all: main livelib.so deadlib.so
 
 main: main.o prov.o
-	gcc -o main main.o
+	gcc -m32 -o main main.o
 
 main.o: main.c
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 
 livelib.so: livelib.o prov.o
-	gcc -shared -o livelib.so livelib.o prov.o -lc
+	gcc -m32 -shared -o livelib.so livelib.o prov.o -lc
 
 livelib.o: livelib.c prov.h
-	gcc -c livelib.c
+	gcc -m32 -fPIC -c livelib.c
 
 prov.o: livelib.o prov.d
 	$dtrace -G -s prov.d livelib.o
@@ -65,10 +65,10 @@
 
 
 deadlib.so: deadlib.o
-	gcc -shared -o deadlib.so deadlib.o -lc
+	gcc -m32 -shared -o deadlib.so deadlib.o -lc
 
 deadlib.o: deadlib.c
-	gcc -c deadlib.c
+	gcc -m32 -fPIC -c deadlib.c
 
 clean:
 	rm -f main.o livelib.o prov.o prov.h deadlib.o
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose2.ksh	2014-01-14 20:12:09.837401222 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose2.ksh	2014-01-14 20:12:09.850673251 -0500
@@ -40,17 +40,17 @@
 all: main livelib.so deadlib.so
 
 main: main.o prov.o
-	gcc -o main main.o
+	gcc -m32 -o main main.o
 
 main.o: main.c
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 
 livelib.so: livelib.o prov.o
-	gcc -shared -o livelib.so livelib.o prov.o -lc
+	gcc -m32 -shared -o livelib.so livelib.o prov.o -lc
 
 livelib.o: livelib.c prov.h
-	gcc -c livelib.c
+	gcc -m32 -fPIC -c livelib.c
 
 prov.o: livelib.o prov.d
 	$dtrace -G -s prov.d livelib.o
@@ -60,10 +60,10 @@
 
 
 deadlib.so: deadlib.o
-	gcc -shared -o deadlib.so deadlib.o -lc
+	gcc -m32 -shared -o deadlib.so deadlib.o -lc
 
 deadlib.o: deadlib.c
-	gcc -c deadlib.c
+	gcc -m32 -fPIC -c deadlib.c
 
 clean:
 	rm -f main.o livelib.o prov.o prov.h deadlib.o
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose3.ksh	2014-01-14 20:12:10.438222623 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.dlclose3.ksh	2014-01-14 20:12:10.451425589 -0500
@@ -45,17 +45,17 @@
 all: main livelib.so deadlib.so
 
 main: main.o prov.o
-	gcc -o main main.o
+	gcc -m32 -o main main.o
 
 main.o: main.c
-	gcc -c main.c
+	gcc -m32 -c main.c
 
 
 livelib.so: livelib.o prov.o
-	gcc -shared -o livelib.so livelib.o prov.o -lc
+	gcc -m32 -shared -o livelib.so livelib.o prov.o -lc
 
 livelib.o: livelib.c prov.h
-	gcc -c livelib.c
+	gcc -m32 -fPIC -c livelib.c
 
 prov.o: livelib.o prov.d
 	$dtrace -G -s prov.d livelib.o
@@ -65,10 +65,10 @@
 
 
 deadlib.so: deadlib.o
-	gcc -shared -o deadlib.so deadlib.o -lc
+	gcc -m32 -shared -o deadlib.so deadlib.o -lc
 
 deadlib.o: deadlib.c
-	gcc -c deadlib.c
+	gcc -m32 -fPIC -c deadlib.c
 
 clean:
 	rm -f main.o livelib.o prov.o prov.h deadlib.o
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.eliminate.ksh	2014-01-14 20:12:10.858698801 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.eliminate.ksh	2014-01-14 20:12:10.890688388 -0500
@@ -71,7 +71,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -81,7 +81,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.enabled.ksh	2014-01-14 20:12:11.396859246 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.enabled.ksh	2014-01-14 20:12:11.410066099 -0500
@@ -60,7 +60,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -70,7 +70,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.enabled2.ksh	2014-01-14 20:12:11.822144546 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.enabled2.ksh	2014-01-14 20:12:11.853336331 -0500
@@ -76,7 +76,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -86,7 +86,8 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.entryreturn.ksh	2014-01-14 20:12:12.303207190 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.entryreturn.ksh	2014-01-14 20:12:12.317721741 -0500
@@ -69,7 +69,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -79,7 +79,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.fork.ksh	2014-01-14 20:12:12.754442053 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.fork.ksh	2014-01-14 20:12:12.779376007 -0500
@@ -70,7 +70,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -80,7 +80,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.header.ksh	2014-01-14 20:12:13.210708906 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.header.ksh	2014-01-14 20:12:13.224464256 -0500
@@ -64,7 +64,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -74,7 +74,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.linkpriv.ksh	2014-01-14 20:12:13.656873821 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.linkpriv.ksh	2014-01-14 20:12:13.671487722 -0500
@@ -61,7 +61,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -71,7 +71,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.linkunpriv.ksh	2014-01-14 20:12:14.117458816 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.linkunpriv.ksh	2014-01-14 20:12:14.130733270 -0500
@@ -63,7 +63,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -73,7 +73,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.multiple.ksh	2014-01-14 20:12:14.539474559 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.multiple.ksh	2014-01-14 20:12:14.552758487 -0500
@@ -64,7 +64,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -74,7 +74,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.multiprov.ksh	2014-01-14 20:12:15.069572045 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.multiprov.ksh	2014-01-14 20:12:15.083120304 -0500
@@ -64,7 +64,7 @@
 };
 EOF
 
-	cc -c $oogle.c
+	gcc -m32 -c $oogle.c
 
 	if [ $? -ne 0 ]; then
 		print -u2 "failed to compile $oogle.c"
@@ -87,7 +87,7 @@
 
 echo 'END{printa("%-10s %@d\\n", @)}' >> test.d
 
-cc -o test test.c $objs
+gcc -m32 -o test test.c $objs
 
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noprobes.ksh	2014-01-14 20:12:15.574066963 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noprobes.ksh	2014-01-14 20:12:15.587463505 -0500
@@ -46,7 +46,7 @@
 };
 EOF
 
-cc -c test.c
+gcc -m32 -c test.c
 $dtrace -G -32 -s doogle.d test.o -o doogle.d.o
 
 if [ $? -eq 0 ]; then
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noreap.ksh	2014-01-14 20:12:16.001778611 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noreap.ksh	2014-01-14 20:12:16.029742760 -0500
@@ -51,7 +51,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -61,7 +61,8 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noreapring.ksh	2014-01-14 20:12:16.480176521 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.noreapring.ksh	2014-01-14 20:12:16.494576387 -0500
@@ -51,7 +51,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -61,7 +61,8 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.onlyenabled.ksh	2014-01-14 20:12:16.932454632 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.onlyenabled.ksh	2014-01-14 20:12:16.957723694 -0500
@@ -61,7 +61,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -71,7 +71,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.reap.ksh	2014-01-14 20:12:17.386790550 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.reap.ksh	2014-01-14 20:12:17.401239567 -0500
@@ -51,7 +51,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -61,7 +61,8 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.reeval.ksh	2014-01-14 20:12:17.850615844 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.reeval.ksh	2014-01-14 20:12:17.865456625 -0500
@@ -51,7 +51,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -61,7 +61,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.static.ksh	2014-01-14 20:12:18.340731822 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.static.ksh	2014-01-14 20:12:18.356996667 -0500
@@ -62,7 +62,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -72,7 +72,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.static2.ksh	2014-01-14 20:12:18.809797585 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.static2.ksh	2014-01-14 20:12:18.835674116 -0500
@@ -66,7 +66,7 @@
 };
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -82,7 +82,7 @@
 	print -u2 "failed to create final DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/common/usdt/tst.user.ksh	2014-01-14 20:12:19.266702596 -0500
+++ new/usr/src/cmd/dtrace/test/tst/common/usdt/tst.user.ksh	2014-01-14 20:12:19.287418058 -0500
@@ -61,7 +61,7 @@
 }
 EOF
 
-gcc -c test.c
+gcc -m32 -c test.c
 if [ $? -ne 0 ]; then
 	print -u2 "failed to compile test.c"
 	exit 1
@@ -71,7 +71,7 @@
 	print -u2 "failed to create DOF"
 	exit 1
 fi
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/cmd/dtrace/test/tst/sparc/usdt/tst.tailcall.ksh	2014-01-14 20:12:19.730955330 -0500
+++ new/usr/src/cmd/dtrace/test/tst/sparc/usdt/tst.tailcall.ksh	2014-01-14 20:12:19.745358230 -0500
@@ -87,7 +87,7 @@
 	exit 1
 fi
 
-gcc -o test test.o prov.o
+gcc -m32 -o test test.o prov.o
 if [ $? -ne 0 ]; then
 	print -u2 "failed to link final executable"
 	exit 1
--- old/usr/src/common/ctf/ctf_open.c	2014-01-14 20:12:20.469498660 -0500
+++ new/usr/src/common/ctf/ctf_open.c	2014-01-14 20:12:20.483202787 -0500
@@ -25,7 +25,7 @@
  * Use is subject to license terms.
  */
 /*
- * Copyright (c) 2012, Joyent, Inc.  All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc.  All rights reserved.
  */
 
 #include <ctf_impl.h>
@@ -788,6 +788,92 @@
 }
 
 /*
+ * Dupliate a ctf_file_t and its underlying section information into a new
+ * container. This works by copying the three ctf_sect_t's of the original
+ * container if they exist and passing those into ctf_bufopen. To copy those, we
+ * mmap anonymous memory with ctf_data_alloc and bcopy the data across. It's not
+ * the cheapest thing, but it's what we've got.
+ */
+ctf_file_t *
+ctf_dup(ctf_file_t *ofp)
+{
+	ctf_file_t *fp;
+	ctf_sect_t ctfsect, symsect, strsect;
+	ctf_sect_t *ctp, *symp, *strp;
+	void *cbuf, *symbuf, *strbuf;
+	int err;
+
+	cbuf = symbuf = strbuf = NULL;
+	/*
+	 * The ctfsect isn't allowed to not exist, but the symbol and string
+	 * section might not. We only need to copy the data of the section, not
+	 * the name, as ctf_bufopen will take care of that.
+	 */
+	bcopy(&ofp->ctf_data, &ctfsect, sizeof (ctf_sect_t));
+	cbuf = ctf_data_alloc(ctfsect.cts_size);
+	if (cbuf == NULL) {
+		(void) ctf_set_errno(ofp, ECTF_MMAP);
+		return (NULL);
+	}
+
+	bcopy(ctfsect.cts_data, cbuf, ctfsect.cts_size);
+	ctf_data_protect(cbuf, ctfsect.cts_size);
+	ctfsect.cts_data = cbuf;
+	ctfsect.cts_offset = 0;
+	ctp = &ctfsect;
+
+	if (ofp->ctf_symtab.cts_data != NULL) {
+		bcopy(&ofp->ctf_symtab, &symsect, sizeof (ctf_sect_t));
+		symbuf = ctf_data_alloc(symsect.cts_size);
+		if (symbuf == NULL) {
+			(void) ctf_set_errno(ofp, ECTF_MMAP);
+			goto err;
+		}
+		bcopy(symsect.cts_data, symbuf, symsect.cts_size);
+		ctf_data_protect(symbuf, symsect.cts_size);
+		symsect.cts_data = symbuf;
+		symsect.cts_offset = 0;
+		symp = &symsect;
+	} else {
+		symp = NULL;
+	}
+
+	if (ofp->ctf_strtab.cts_data != NULL) {
+		bcopy(&ofp->ctf_strtab, &strsect, sizeof (ctf_sect_t));
+		strbuf = ctf_data_alloc(strsect.cts_size);
+		if (strbuf == NULL) {
+			(void) ctf_set_errno(ofp, ECTF_MMAP);
+			goto err;
+		}
+		bcopy(strsect.cts_data, strbuf, strsect.cts_size);
+		ctf_data_protect(strbuf, strsect.cts_size);
+		strsect.cts_data = strbuf;
+		strsect.cts_offset = 0;
+		strp = &strsect;
+	} else {
+		strp = NULL;
+	}
+
+	fp = ctf_bufopen(ctp, symp, strp, &err);
+	if (fp == NULL) {
+		(void) ctf_set_errno(ofp, err);
+		goto err;
+	}
+
+	fp->ctf_flags |= LCTF_MMAP;
+
+	return (fp);
+
+err:
+	ctf_data_free(cbuf, ctfsect.cts_size);
+	if (symbuf != NULL)
+		ctf_data_free(symbuf, symsect.cts_size);
+	if (strbuf != NULL)
+		ctf_data_free(strbuf, strsect.cts_size);
+	return (NULL);
+}
+
+/*
  * Close the specified CTF container and free associated data structures.  Note
  * that ctf_close() is a reference counted operation: if the specified file is
  * the parent of other active containers, its reference count will be greater
--- old/usr/src/common/ctf/ctf_types.c	2014-01-14 20:12:20.973610356 -0500
+++ new/usr/src/common/ctf/ctf_types.c	2014-01-14 20:12:20.987860644 -0500
@@ -25,8 +25,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <ctf_impl.h>
 
 ssize_t
@@ -199,8 +197,9 @@
  * Lookup the given type ID and print a string name for it into buf.  Return
  * the actual number of bytes (not including \0) needed to format the name.
  */
-ssize_t
-ctf_type_lname(ctf_file_t *fp, ctf_id_t type, char *buf, size_t len)
+static ssize_t
+ctf_type_qlname(ctf_file_t *fp, ctf_id_t type, char *buf, size_t len,
+    const char *qname)
 {
 	ctf_decl_t cd;
 	ctf_decl_node_t *cdp;
@@ -255,6 +254,8 @@
 			case CTF_K_INTEGER:
 			case CTF_K_FLOAT:
 			case CTF_K_TYPEDEF:
+				if (qname != NULL)
+					ctf_decl_sprintf(&cd, "%s`", qname);
 				ctf_decl_sprintf(&cd, "%s", name);
 				break;
 			case CTF_K_POINTER:
@@ -268,13 +269,22 @@
 				break;
 			case CTF_K_STRUCT:
 			case CTF_K_FORWARD:
-				ctf_decl_sprintf(&cd, "struct %s", name);
+				ctf_decl_sprintf(&cd, "struct ");
+				if (qname != NULL)
+					ctf_decl_sprintf(&cd, "%s`", qname);
+				ctf_decl_sprintf(&cd, "%s", name);
 				break;
 			case CTF_K_UNION:
-				ctf_decl_sprintf(&cd, "union %s", name);
+				ctf_decl_sprintf(&cd, "union ");
+				if (qname != NULL)
+					ctf_decl_sprintf(&cd, "%s`", qname);
+				ctf_decl_sprintf(&cd, "%s", name);
 				break;
 			case CTF_K_ENUM:
-				ctf_decl_sprintf(&cd, "enum %s", name);
+				ctf_decl_sprintf(&cd, "enum ");
+				if (qname != NULL)
+					ctf_decl_sprintf(&cd, "%s`", qname);
+				ctf_decl_sprintf(&cd, "%s", name);
 				break;
 			case CTF_K_VOLATILE:
 				ctf_decl_sprintf(&cd, "volatile");
@@ -301,6 +311,12 @@
 	return (cd.cd_len);
 }
 
+ssize_t
+ctf_type_lname(ctf_file_t *fp, ctf_id_t type, char *buf, size_t len)
+{
+	return (ctf_type_qlname(fp, type, buf, len, NULL));
+}
+
 /*
  * Lookup the given type ID and print a string name for it into buf.  If buf
  * is too small, return NULL: the ECTF_NAMELEN error is set on 'fp' for us.
@@ -308,10 +324,19 @@
 char *
 ctf_type_name(ctf_file_t *fp, ctf_id_t type, char *buf, size_t len)
 {
-	ssize_t rv = ctf_type_lname(fp, type, buf, len);
+	ssize_t rv = ctf_type_qlname(fp, type, buf, len, NULL);
+	return (rv >= 0 && rv < len ? buf : NULL);
+}
+
+char *
+ctf_type_qname(ctf_file_t *fp, ctf_id_t type, char *buf, size_t len,
+    const char *qname)
+{
+	ssize_t rv = ctf_type_qlname(fp, type, buf, len, qname);
 	return (rv >= 0 && rv < len ? buf : NULL);
 }
 
+
 /*
  * Resolve the type down to a base type node, and then return the size
  * of the type storage in bytes.
--- old/usr/src/lib/libctf/common/mapfile-vers	2014-01-14 20:12:21.559438067 -0500
+++ new/usr/src/lib/libctf/common/mapfile-vers	2014-01-14 20:12:21.589519355 -0500
@@ -23,6 +23,10 @@
 #
 
 #
+# Copyright (c) 2013, Joyent, Inc.  All rights reserved.
+#
+
+#
 # MAPFILE HEADER START
 #
 # WARNING:  STOP NOW.  DO NOT MODIFY THIS FILE.
@@ -62,6 +66,7 @@
 	ctf_create;
 	ctf_delete_type;
 	ctf_discard;
+	ctf_dup;
 	ctf_enum_value;
 	ctf_label_info;
 	ctf_label_iter;
@@ -104,6 +109,7 @@
 	ctf_type_kind;
 	ctf_type_lname;
 	ctf_type_name;
+	ctf_type_qname;
 	ctf_type_reference;
 	ctf_type_resolve;
 	ctf_type_size;
--- old/usr/src/lib/libdtrace/common/dt_as.c	2014-01-14 20:12:22.037994841 -0500
+++ new/usr/src/lib/libdtrace/common/dt_as.c	2014-01-14 20:12:22.066053275 -0500
@@ -23,8 +23,10 @@
  * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
-
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013 Joyent, Inc. All rights reserved.
+ */
 
 #include <sys/types.h>
 #include <strings.h>
@@ -125,7 +127,7 @@
 		dvp->dtdv_flags |= DIFV_F_MOD;
 
 	bzero(&dn, sizeof (dn));
-	dt_node_type_assign(&dn, idp->di_ctfp, idp->di_type);
+	dt_node_type_assign(&dn, idp->di_ctfp, idp->di_type, B_FALSE);
 	dt_node_diftype(pcb->pcb_hdl, &dn, &dvp->dtdv_type);
 
 	idp->di_flags &= ~(DT_IDFLG_DIFR | DT_IDFLG_DIFW);
--- old/usr/src/lib/libdtrace/common/dt_cc.c	2014-01-14 20:12:22.542704521 -0500
+++ new/usr/src/lib/libdtrace/common/dt_cc.c	2014-01-14 20:12:22.572327114 -0500
@@ -21,7 +21,7 @@
 
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2011, Joyent Inc. All rights reserved.
+ * Copyright (c) 2013, Joyent Inc. All rights reserved.
  * Copyright (c) 2012 by Delphix. All rights reserved.
  */
 
@@ -662,6 +662,8 @@
 static void
 dt_action_trace(dtrace_hdl_t *dtp, dt_node_t *dnp, dtrace_stmtdesc_t *sdp)
 {
+	int ctflib;
+
 	dtrace_actdesc_t *ap = dt_stmt_action(dtp, sdp);
 	boolean_t istrace = (dnp->dn_ident->di_id == DT_ACT_TRACE);
 	const char *act = istrace ?  "trace" : "print";
@@ -693,7 +695,10 @@
 	 * like arrays and function pointers that can't be resolved by
 	 * ctf_type_lookup().  This is later processed by dtrace_dof_create()
 	 * and turned into a reference into the string table so that we can
-	 * get the type information when we process the data after the fact.
+	 * get the type information when we process the data after the fact.  In
+	 * the case where we are referring to userland CTF data, we also need to
+	 * to identify which ctf container in question we care about and encode
+	 * that within the name.
 	 */
 	if (dnp->dn_ident->di_id == DT_ACT_PRINT) {
 		dt_node_t *dret;
@@ -703,12 +708,25 @@
 		dret = yypcb->pcb_dret;
 		dmp = dt_module_lookup_by_ctf(dtp, dret->dn_ctfp);
 
-		n = snprintf(NULL, 0, "%s`%d", dmp->dm_name, dret->dn_type) + 1;
+		if (dmp->dm_pid != 0) {
+			ctflib = dt_module_getlibid(dtp, dmp, dret->dn_ctfp);
+			assert(ctflib >= 0);
+			n = snprintf(NULL, 0, "%s`%d`%d", dmp->dm_name,
+			    ctflib, dret->dn_type) + 1;
+		} else {
+			n = snprintf(NULL, 0, "%s`%d", dmp->dm_name,
+			    dret->dn_type) + 1;
+		}
 		sdp->dtsd_strdata = dt_alloc(dtp, n);
 		if (sdp->dtsd_strdata == NULL)
 			longjmp(yypcb->pcb_jmpbuf, EDT_NOMEM);
-		(void) snprintf(sdp->dtsd_strdata, n, "%s`%d", dmp->dm_name,
-		    dret->dn_type);
+		if (dmp->dm_pid != 0) {
+			(void) snprintf(sdp->dtsd_strdata, n, "%s`%d`%d",
+			    dmp->dm_name, ctflib, dret->dn_type);
+		} else {
+			(void) snprintf(sdp->dtsd_strdata, n, "%s`%d",
+			    dmp->dm_name, dret->dn_type);
+		}
 	}
 
 	ap->dtad_difo = dt_as(yypcb);
--- old/usr/src/lib/libdtrace/common/dt_decl.c	2014-01-14 20:12:23.200048018 -0500
+++ new/usr/src/lib/libdtrace/common/dt_decl.c	2014-01-14 20:12:23.215779033 -0500
@@ -21,7 +21,8 @@
 
 /*
  * Copyright (c) 2003, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013 Joyent, Inc. All rights reserved.
  */
 
 #include <strings.h>
@@ -775,7 +776,7 @@
 	yyintdecimal = 0;
 
 	dnp = dt_node_int(value);
-	dt_node_type_assign(dnp, dsp->ds_ctfp, dsp->ds_type);
+	dt_node_type_assign(dnp, dsp->ds_ctfp, dsp->ds_type, B_FALSE);
 
 	if ((inp = malloc(sizeof (dt_idnode_t))) == NULL)
 		longjmp(yypcb->pcb_jmpbuf, EDT_NOMEM);
@@ -817,6 +818,8 @@
 	char *name;
 	int rv;
 
+	tip->dtt_flags = 0;
+
 	/*
 	 * Based on our current #include depth and decl stack depth, determine
 	 * which dynamic CTF module and scope to use when adding any new types.
@@ -824,6 +827,9 @@
 	dmp = yypcb->pcb_idepth ? dtp->dt_cdefs : dtp->dt_ddefs;
 	flag = yypcb->pcb_dstack.ds_next ? CTF_ADD_NONROOT : CTF_ADD_ROOT;
 
+	if (ddp->dd_attr & DT_DA_USER)
+		tip->dtt_flags = DTT_FL_USER;
+
 	/*
 	 * If we have already cached a CTF type for this decl, then we just
 	 * return the type information for the cached type.
--- old/usr/src/lib/libdtrace/common/dt_decl.h	2014-01-14 20:12:23.726588375 -0500
+++ new/usr/src/lib/libdtrace/common/dt_decl.h	2014-01-14 20:12:23.747436960 -0500
@@ -23,12 +23,14 @@
  * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013 Joyent, Inc. All rights reserved.
+ */
 
 #ifndef	_DT_DECL_H
 #define	_DT_DECL_H
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <libctf.h>
 #include <dtrace.h>
@@ -59,6 +61,7 @@
 #define	DT_DA_RESTRICT	0x0040		/* qualify type as restrict */
 #define	DT_DA_VOLATILE	0x0080		/* qualify type as volatile */
 #define	DT_DA_PAREN	0x0100		/* parenthesis tag */
+#define	DT_DA_USER	0x0200		/* user-land type specifier */
 
 typedef enum dt_dclass {
 	DT_DC_DEFAULT,			/* no storage class specified */
--- old/usr/src/lib/libdtrace/common/dt_dis.c	2014-01-14 20:12:24.163005795 -0500
+++ new/usr/src/lib/libdtrace/common/dt_dis.c	2014-01-14 20:12:24.176463365 -0500
@@ -26,7 +26,8 @@
  */
 
 /*
- * Copyright (c) 2012 by Delphix. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013 Joyent, Inc. All rights reserved.
  */
 
 #include <strings.h>
@@ -312,9 +313,10 @@
 		(void) snprintf(ckind, sizeof (ckind), "0x%x", t->dtdt_ckind);
 	}
 
-	if (t->dtdt_flags & DIF_TF_BYREF) {
-		(void) snprintf(buf, len, "%s (%s) by ref (size %lu)",
-		    kind, ckind, (ulong_t)t->dtdt_size);
+	if (t->dtdt_flags & (DIF_TF_BYREF | DIF_TF_BYUREF)) {
+		(void) snprintf(buf, len, "%s (%s) by %sref (size %lu)",
+		    kind, ckind, (t->dtdt_flags & DIF_TF_BYUREF) ? "user " : "",
+		    (ulong_t)t->dtdt_size);
 	} else {
 		(void) snprintf(buf, len, "%s (%s) (size %lu)",
 		    kind, ckind, (ulong_t)t->dtdt_size);
--- old/usr/src/lib/libdtrace/common/dt_error.c	2014-01-14 20:12:24.615041630 -0500
+++ new/usr/src/lib/libdtrace/common/dt_error.c	2014-01-14 20:12:24.628463144 -0500
@@ -110,7 +110,8 @@
 	{ EDT_BADAGGVAR, "Invalid aggregation variable identifier" },
 	{ EDT_OVERSION,	"Client requested deprecated version of library" },
 	{ EDT_ENABLING_ERR, "Failed to enable probe" },
-	{ EDT_NOPROBES, "No probe sites found for declared provider" }
+	{ EDT_NOPROBES, "No probe sites found for declared provider" },
+	{ EDT_CANTLOAD, "Failed to load module" },
 };
 
 static const int _dt_nerr = sizeof (_dt_errlist) / sizeof (_dt_errlist[0]);
--- old/usr/src/lib/libdtrace/common/dt_grammar.y	2014-01-14 20:12:25.107813525 -0500
+++ new/usr/src/lib/libdtrace/common/dt_grammar.y	2014-01-14 20:12:25.180747141 -0500
@@ -23,8 +23,10 @@
  * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
-
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
 
 #include <dt_impl.h>
 
@@ -102,6 +104,7 @@
 %token	DT_KEY_TYPEDEF
 %token	DT_KEY_UNION
 %token	DT_KEY_UNSIGNED
+%token	DT_KEY_USERLAND
 %token	DT_KEY_VOID
 %token	DT_KEY_VOLATILE
 %token	DT_KEY_WHILE
@@ -633,6 +636,7 @@
 	|	DT_KEY_DOUBLE { $$ = dt_decl_spec(CTF_K_FLOAT, DUP("double")); }
 	|	DT_KEY_SIGNED { $$ = dt_decl_attr(DT_DA_SIGNED); }
 	|	DT_KEY_UNSIGNED { $$ = dt_decl_attr(DT_DA_UNSIGNED); }
+	|	DT_KEY_USERLAND { $$ = dt_decl_attr(DT_DA_USER); }
 	|	DT_KEY_STRING {
 			$$ = dt_decl_spec(CTF_K_TYPEDEF, DUP("string"));
 		}
